#define prever rc8d

# Comma separated list of cards for which to compile a driver
%{!?cards: %{expand: %%define cards all}}

# "uname -r" output of the kernel to build for, the running one
# if none was specified with "--define 'kernel <uname -r>'"
%{!?kernel: %{expand: %%define	kernel		%(uname -r)}}

%define	kversion	%(echo %{kernel} | sed -e s/smp// -)
%define	krelver		%(echo %{kversion} | tr -s '-' '_')
%if %(echo %{kernel} | grep -c smp)
	%{expand:%%define ksmp -smp}
%endif

Summary: The Advanced Linux Sound Architecture (ALSA) base files.
Name: alsa-driver
Version: 0.9.2
Release: 2
License: GPL
Group: System Environment/Base
Source0: ftp://ftp.alsa-project.org/pub/driver/%{name}-%{version}.tar.bz2
Source1: alsa-makedev.d.txt
Patch0: alsa-driver-depmod.patch
URL: http://www.alsa-project.org/
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: kernel-source = %{kversion}, MAKEDEV

%description
The Advanced Linux Sound Architecture (ALSA) provides audio and MIDI
functionality to the Linux operating system. ALSA has the following
significant features: Efficient support for all types of audio interfaces,
from consumer soundcards to professional multichannel audio interfaces,
fully modularized sound drivers, SMP and thread-safe design, user space
library (alsa-lib) to simplify application programming and provide higher
level functionality as well as support for the older OSS API, providing
binary compatibility for most OSS programs.

This package contains the ALSA /dev entries and basic development files.

Available rpmbuild rebuild options :
--without : isapnp sequencer oss

You may also recompile for given cards only by calling rpmbuild with :
--define "cards card1,card2,card3"
(the default is "cards all")

You may also recompile for a given kernel version and arch with :
--define "kernel <uname -r output>"
(for example "kernel 2.4.20-5")
--target <arch>


%package -n alsa-kernel%{?ksmp}
Summary: The Advanced Linux Sound Architecture (ALSA) kernel drivers.
Release: %{release}_%{krelver}
Group: System Environment/Kernel
Requires: alsa-driver = %{version}
Requires: kernel%{?ksmp} = %{kversion}, /sbin/depmod
%{?ksmp:Provides: alsa-kernel = %{version}}

%description -n alsa-kernel%{?ksmp}
The Advanced Linux Sound Architecture (ALSA) provides audio and MIDI
functionality to the Linux operating system. ALSA has the following
significant features: Efficient support for all types of audio interfaces,
from consumer soundcards to professional multichannel audio interfaces,
fully modularized sound drivers, SMP and thread-safe design, user space
library (alsa-lib) to simplify application programming and provide higher
level functionality as well as support for the older OSS API, providing
binary compatibility for most OSS programs.

This package contains the ALSA kernel modules for the Linux kernel package :
%{kversion} (%{_target_cpu}%{?ksmp:, SMP}).


%prep
%setup -q -n %{name}-%{version}%{?prever}
%patch0 -p1 -b .nodepmod

%build
%configure \
	--with-kernel=/usr/src/linux-%{kversion} \
	--with-moddir=/lib/modules/%{kernel}/kernel/sound \
	%{?_without_isapnp:--with-isapnp=no} \
	%{?_without_sequencer:--with-sequencer=no} \
	%{?_without_oss:--with-oss=no} \
	--with-cards=%{cards}

# Temporary Rawhide kernel workaround - Disable ALSA workqueue wrapper
#touch include/linux/workqueue.h

make MODFLAGS="-DMODULE=1 -D__BOOT_KERNEL_H_ -D__MODULE_KERNEL_%{_target_cpu}=1 %{?ksmp:-D__BOOT_KERNEL_SMP=1} %{!?ksmp:-D__BOOT_KERNEL_UP=1}"

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}/etc/rc.d/init.d/
make install \
  IUSER=`id -un` \
  IGROUP=`id -gn` \
  DESTDIR=%{buildroot}

# Install and generate all the device stuff
install -m 644 -D %{SOURCE1} %{buildroot}%{_sysconfdir}/makedev.d/alsa
cp -a %{_sysconfdir}/makedev.d/00macros %{buildroot}%{_sysconfdir}/makedev.d/
rm -f devices

# Create device link and entry list
mkdir -p %{buildroot}/dev
ln -s /proc/asound/dev %{buildroot}/dev/snd
/dev/MAKEDEV \
	-c %{buildroot}%{_sysconfdir}/makedev.d \
	-d %{buildroot}/dev -M alsa | sed 's|%{buildroot}||g' > device.list

# Remove from the included docs
rm -f doc/Makefile

# Remove for default rpm 4.1 to not fail
rm -f %{buildroot}%{_sysconfdir}/makedev.d/00macros
rm -f %{buildroot}/etc/rc.d/init.d/alsasound

%post -n alsa-kernel%{?ksmp}
/sbin/depmod -a -F /boot/System.map-%{kernel} %{kernel} >/dev/null 2>&1 || :

%postun -n alsa-kernel%{?ksmp}
/sbin/depmod -a -F /boot/System.map-%{kernel} %{kernel} >/dev/null 2>&1 || :

%clean
rm -rf %{buildroot}

%files -f device.list
%defattr(-, root, root)
%doc CARDS-STATUS COPYING FAQ README TODO WARNING
%doc doc/ alsa-kernel/Documentation/
/dev/snd
%{_sysconfdir}/makedev.d/alsa
%{_includedir}/sound

%files -n alsa-kernel%{?ksmp}
%defattr(-, root, root)
/lib/modules/%{kernel}/kernel/sound

%changelog
* Sat Apr 5 2003 Jason Luka <jason@geshp.com>
- Rebuilt on Red Hat 9

* Thu Mar 27 2003 Jason Luka <jason@geshp.com>
- Rebuilt for videolan site

* Wed Mar 19 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.9.2.

* Mon Mar 17 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Removed now unneeded vmalloc patch.

* Tue Mar 11 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.9.0rc8d.
- Update to 0.9.1!

* Mon Mar  3 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.9.0rc8.
- Removed CFLAGS patch, use new MODFLAGS instead.

* Wed Feb 12 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Merge fixes for /sbin/depmod dep and its post/postun scripts.
- Add CFLAGS patch and changes to rebuild for any arch with just the
  right kernel-source installed.
- Minor cleanups inherent to the above.

* Mon Feb  3 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.9.0rc7.
- Added ability to recompile against non-running kernel.

* Mon Nov 16 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.9.0rc6.

* Fri Oct 25 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Silent the %%post and %%postun scriplets to avoid unresolved symbol
  warnings during upgrades.

* Wed Oct 23 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.9.0rc4, then rc5.

* Tue Oct  1 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Removed the dependency about alsa-driver in alsa-kernel to fix apt problems.

* Sun Sep 29 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Added -smp to alsa-kernel packages for SMP systems (needs testing).

* Fri Sep 27 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Moved rpmbuild --without options to the description.
- Rebuild for Red Hat Linux 8.0.
- Fixed the /sbin/depmod -a that was run for the wrong sub-package, doh!

* Tue Sep 17 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Fixed yet another (last?) bug on SMP systems.

* Sun Sep  8 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Fixed build on SMP systems, thanks to Chris Ckloiber.

* Thu Aug 29 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Fixed extra files problem with rpm 4.1.
- Added support for disabling isapnp, sequencer and oss.
- Added support to easily modify to build only drivers for specific cards.
- Simplified the device list creation ("alsa" alias in the makedev.d entry).
- Fixed reversed links in the /dev entries.

* Wed Aug 28 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Fix the makedev file that didn't like the CVS tag.
- New sub-package -kernel with only the kernel module (to have multiple
  installations of it easily).
- Fixed kernel arch detection by invoking rpm to query kernel package ;-)

* Tue Aug 27 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Spec file rewrite.
- Added makedev.d stuff to have device files included cleanly.

